#include"delay.h"
 #define LCDPORT P2
sbit RS=LCDPORT^2;
sbit E=LCDPORT^3;
 void latch(void)
{
    E = 1;
    delay(1);
    E = 0;
}

void lcd_cmd(unsigned char c)
{
RS = 0;
delay(1);
LCDPORT = c & 0xf0;
latch();
delay(1); 
LCDPORT =  (c << 4);
latch(); 
}

 void lcd_data(unsigned char c)
 {
 //RS =1;
 delay(1);
LCDPORT = c & 0xf0 | 0x4;
delay(1);
latch();

LCDPORT = (c << 4)| 0x4; ;
latch(); 
}
 
void lcd_init()
{
  delay(20);
    lcd_cmd(0x33);
  delay(20);
    lcd_cmd(0x33);
  delay(4);
    lcd_cmd(0x32);
	delay(4);
    lcd_cmd(0x28);            // Function set (4-bit interface, 2 lines, 5*7Pixels)
    lcd_cmd(0x28);            // Function set (4-bit interface, 2 lines, 5*7Pixels)
    lcd_cmd(0x0c);            // Make cursorinvisible
    lcd_cmd(0x6);            // Set entry Mode(auto increment of cursor)
}

 void string(const char *q)
{
    while (*q) {
        lcd_data(*q++);
    }
}
